<template>
  <b-row>
    <b-col cols="12" xl="12" v-loading="listLoading">
      <transition name="slide">
        <b-card>
          <div slot="header" v-html="caption"></div>
          <el-form :inline="true" class="demo-form-inline">
            <el-form-item label="Code">
              <el-input v-model="tblParams.code" placeholder="Search by code"></el-input>
            </el-form-item>
            <el-form-item label="Name">
              <el-input v-model="tblParams.name" placeholder="Search by name"></el-input>
            </el-form-item>
            <el-form-item>
              <el-button type="primary" @click="()=>refreshData()">Search</el-button>
              <el-button type="default" @click="()=>clearData()">Clear</el-button>
            </el-form-item>
          </el-form>
          <el-row>
            <el-button type="primary" @click="()=>addCategory()">Add</el-button>
          </el-row>
          <el-table
            :data="categories"
            @row-dblclick="rowDblclick"
            border
            highlight-current-row
            @sort-change="sortChange"
            style="width: 100%"
            
          >
            <el-table-column fixed type="index" width="40" label="#">
              <template
                slot-scope="scope"
              >{{(tblParams.currentPage - 1) * tblParams.perPage + (scope.$index + 1)}}</template>
            </el-table-column>
            <el-table-column fixed prop="code" sortable="custom" label="CODE" width="150"></el-table-column>
            <el-table-column prop="name" label="Name" sortable="custom"></el-table-column>
            <el-table-column prop="description" label="Description" width="4200"></el-table-column>
            <el-table-column fixed="right" label="Operations" width="120">
              <template slot-scope="scope">
                <el-tooltip content="Edit category" placement="bottom" effect="light">
                  <el-button @click="rowClicked(scope.$index)" type="text" size="small">Edit</el-button>
                </el-tooltip>
                <el-tooltip content="Delete category" placement="bottom" effect="light">
                  <el-button
                    @click.native.prevent="deleteCategory(scope.$index)"
                    type="text"
                    size="small"
                  >Remove</el-button>
                </el-tooltip>
              </template>
            </el-table-column>
          </el-table>
          <pagination
            v-show="true"
            :total="totalRows"
            :page.sync="tblParams.currentPage"
            :limit.sync="tblParams.perPage"
            @pagination="fetchCategoriesList(tblParams)"
          />
        </b-card>
      </transition>
    </b-col>
  </b-row>
</template>

<script>
import { mapGetters } from "vuex"
import { CATEGORY_LIST_PAGE, CATEGORY_DELETE } from "../../store/actions.type"
import { SET_CATEGORY, SET_CATEGORIES } from "../../store/mutations.type"
import Pagination from '@/components/Pagination/Pagination'

export default {
  name: "CategoriesList",
  components: { Pagination },
  data() {
    return {
      caption: "Categories",
      tblParams: {
        name: '',
        code: '',
        currentPage: 1,
        perPage: 10,
        sortField: null,
        sortOrder: null
      },
      totalRows: 0,
      listLoading: false,
    }
  },
  computed: {
    ...mapGetters(['categories'])
  },
  created() {
    this.fetchCategoriesList(this.tblParams)
  },
  methods: {
    async fetchCategoriesList(params) {
      this.listLoading = true
      this.totalRows = await this.$store.dispatch(CATEGORY_LIST_PAGE, params)
      this.listLoading = false
    },
    setSelectedCategory(category) {
      this.$store.commit(SET_CATEGORY, category)
    },
    rowDblclick(row, col, evt) {
      this.$router.push({ path: `category/${row.id}` })
    },
    rowClicked(index) {
      let selectedCategory = this.categories[index]
      this.$router.push({ path: `category/${selectedCategory.id}` })
      // this.$router.push({ path: "category/" + item.id })
    },
    getRowCount() {
      return this.categories.length
    },
    refreshData() {
      this.fetchCategoriesList(this.tblParams)
    },
    clearData() {
      this.tblParams = {
        name: '',
        code: '',
        currentPage: 1,
        perPage: 10,
        sortField: null,
        sortOrder: null
      }
      this.refreshData()
    },
    addCategory() {
      this.$router.push({ path: `category/` })
    },
    deleteCategory(index) {
      var item = this.categories[index]
      var code = item.code
      var content = `This will permanently delete the category with name ${code}. Continue?`
      this.$confirm(content, "Warning", {
        confirmButtonText: "OK",
        cancelButtonText: "Cancel",
        type: "warning"
      }).then(() => {
        this.$store.dispatch(CATEGORY_DELETE, item)
      }).catch(() => { })
    },
    sortChange(data) {
      const { prop, order } = data
      this.tblParams.sortOrder = order
      this.tblParams.sortField = prop
      // reset page hiện tại về 1
      this.tblParams.currentPage = 1
      this.fetchCategoriesList(this.tblParams)
    },
  },
}
</script>
<style scoped>
.card-body >>> table > tbody > tr > td {
  cursor: pointer;
}
.el-table >>> table > tbody > tr {
  cursor: pointer;
}
</style>
